/*
Copyright (c) 2004 bayside
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.
3. The name of the author may not be used to endorse or promote products
   derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#if !defined(_SCROLLBAR_H_INCLUDED_)
#define _SCROLLBAR_H_INCLUDED_

/**
 EXN[o[NX
*/
class Scrollbar : public Control {
public:
	/** XN[o[ */
	static const int HORIZONTAL = 0;
	/** XN[o[ */
	static const int VERTICAL   = 1;
	
private:
	/** XN[o[̎ */
	int orientation;
	/** ŏl */
	int minimum;
	/** ől */
	int maximum;
	/** xɑ */
	int blocksize;
	/** ݂̒l */
	int value;
	/** ubNCxg */
	Event blockEvent;
	
public:
	/** ftHgRXgN^ */
	Scrollbar();

	/** RXgN^ */
	Scrollbar(int orientation);

	/** fXgN^ */
	virtual ~Scrollbar();

	/** ŏl𓾂il0j */
	inline int getMinimum() { return this->minimum; }

	/** ől𓾂il100j */
	inline int getMaximum() { return this->maximum; }

	/** xɑʂ𓾂il10j */
	inline int getBlocksize() { return this->blocksize; }

	/** l𓾂 */
	inline int getValue() { return this->value; }

	/** ŏlݒ肷 */
	inline void setMinimum(int n) { this->minimum = n; }

	/** őlݒ肷 */
	inline void setMaximum(int n) { this->maximum = n; }

	/** xɑʂݒ肷 */
	inline void setBlocksize(int n) { this->blocksize = n; }

	/** lݒ肷 */
	virtual void setValue(int value);

	/**
	 ȋ傫ݒ肷.
	 XN[o[͕̎16ŒAXN[o[̂Ƃ͍16ŒB
	 ȊO̒lݒ肵Ă16ɂȂB
	*/
	virtual void setRect(int x, int y, int w, int h);

	/** `nh */
	virtual void onPaint(Graphics *g);

	/** Cxgnh */
	virtual void onEvent(Event *event);
};

#endif /* _SCROLLBAR_H_INCLUDED_ */
