/*
Copyright (c) 2004 bayside
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.
3. The name of the author may not be used to endorse or promote products
   derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#if !defined(_WINDOW_H_INCLUDED_)
#define _WINDOW_H_INCLUDED_

/**
 EBhENX
*/
class Window : public Container {
public:
	//
	// EBhEItZbg
	//
	/** EBhE[ */
	static const int INSETS_TOP       = 22;
	/** EBhE[ */
	static const int INSETS_BOTTOM    = 6;
	/** EBhE[ */
	static const int INSETS_LEFT      = 6;
	/** EBhEE[ */
	static const int INSETS_RIGHT     = 6;
	
	//
	// EBhȄ
	//
	/** ʏ펞 */
	static const int STATE_NORMAL     = 0;
	/** EBhEړ */
	static const int STATE_MOVING     = 1;

private:
	/** ^Cg */
	String title;
	/** CL[ */
	int modifiers;
	/** EBhȄ */
	int state;
	/** ȑÕ}EXXW */
	int preX;
	/** ȑÕ}EXYW */
	int preY;
	/** ItZbgX */
	int offsetX;
	/** ItZbgY */
	int offsetY;
	/** I[o[bvEBhȄ */
	unsigned int overlap;
	/** stO */
	bool isRunning;
	/** ^C}[ID */
	unsigned int timerID;
	/** L[Cxg */
	KeyEvent keyEvent;
	/** }EXCxg */
	MouseEvent mouseEvent;
	/** ^C}[Cxg */
	Event timerEvent;
	/** JX^Cxg */
	Event customEvent;
	/** `̈ */
	Graphics *_g;
	/** `obt@[ */
	Image *_buffer;
	/** `̈ */
	Graphics *__g;
	/** `obt@[ */
	Image *__buffer;
	
#ifdef MONA
protected:
	/** GUIT[o[̃EBhEIuWFNg */
	guiserver_window *_window;
#endif

public:
	/** RXgN^ */
	Window();
	
	/** fXgN^ */
	virtual ~Window();

	/**
	 inh.
	 Window::run()ŌĂ΂B
	 Ǝ̏t^ƂWindow::onStart()ɌĂԂƁB
	*/
	virtual void onStart();
	
	/**
	 ijnh.
	 fXgN^ŌĂ΂B
	 Ǝ̏t^ƂWindow::onExit()ŌĂԂƁB
	 */
	virtual void onExit();

	/** nh𓾂 */
	unsigned int getHandle();
	
	/** `IuWFNg𓾂 */
	virtual Graphics *getGraphics();
	
	/** obt@[𓾂 */
	virtual Image *getBuffer();
	
	/** ^Cg𓾂 */
	inline char *getTitle() { return this->title.getBytes(); }
	
	/**
	 ^Cgݒ
	 @param title ^Cg
	 */
	virtual void setTitle(char *title);
	
	/**
	 \Ԃݒ肷
	 @param visible \ (true / false)
	 */
	virtual void setVisible(bool visible);
	
	/**
	 ʒuύX
	 @param x XW
	 @param y YW
	*/
	virtual void setLocation(int x, int y);
	
	/**
	 ^C}[Zbg
	 @param duration ^C}[Cxg܂ł̎[ms]
	 */
	virtual void setTimer(int duration);
	
	/** ĕ` */
	virtual void repaint();
	
	/** iXV */
	virtual void update();
	
	/** Cxg */
	virtual void postEvent(Event *event);
	
	/** AvP[V[v𔲂 */
	virtual void stop();
	
	/** AvP[V[v */
	virtual void run();
};

#endif // _WINDOW_H_INCLUDED_
